/**
 * MT4 structure SYMBOL (file format "symbols.raw")
 *
 * Symbols in a file are sorted by name. The symbol id has to be unique but neither to be ascending nor continuous.
 */
struct SYMBOL {                                    // -- offset ---- size --- description ----------------------------------------------------------------------------
   char   name        [MAX_SYMBOL_LENGTH+1];       //         0        12     symbol      (szchar) ie. "AUDCAD.mkt"
   char   description [64];                        //        12        64     description (szchar)
   char   altName     [MAX_SYMBOL_LENGTH+1];       //        76        12     alt name    (szchar) ie. "AUDCAD" (if not equal 'name')
   char   baseCurrency[MAX_SYMBOL_LENGTH+1];       //        88        12     base currency
   UINT   group;                                   //       100         4     index of group in "symgroups.raw"
   UINT   digits;                                  //       104         4     digits

   UINT   tradeMode;                               //       108         4     0=No|1=CloseOnly|2=Full
   UINT   backgroundColor;                         //       112         4     color in "Market Watch" window
   UINT   id;                                      //       116         4     unique symbol id

   BYTE   unknown_1[1508];                         //       120      1508
   UINT   unknown_2;                               //      1628         4     ?
   BYTE   unknown_3[8];                            //      1632         8
   double unknown_4;                               //      1640         8     ?
   BYTE   unknown_5[12];                           //      1648        12

   UINT   spread;                                  //      1660         4     spread in points: 0=current online spread (variable)
   BYTE   unknown_6[16];                           //      1664        16

   double swapLong;                                //      1680         8     swap long
   double swapShort;                               //      1688         8     swap short
   UINT   3daysSwap;                               //      1696         4     Day of week to charge 3 days swap rollover.
   DWORD  unknown_8;                               //      1700         4
   double contractSize;                            //      1704         8     lot size in units
   BYTE   unknown_9[16];                           //      1712        16

   UINT   stopsLevel;                              //      1728         4     stop distance level
   BYTE   unknown_10[12];                          //      1732        12

   double marginInit;                              //      1744         8     margin init        (0 = ContractSize)
   double marginMaintenance;                       //      1752         8     margin maintenance (0 = ContractSize)
   double marginHedged;                            //      1760         8     margin hedged
   double marginDivider;                           //      1768         8     leverage calculation: 0...5 = relative to account leverage (ie. 0.83333 = AccountLeverage/MarginDivider)
                                                   //                                               > 10  = absolute custom leverage     (ie. 100     = 1:100)
   double pointSize;                               //      1776         8     point size
   double pointsPerUnit;                           //      1784         8     points per unit

   BYTE   unknown_11[24];                          //      1792        24
   char   marginCurrency[MAX_SYMBOL_LENGTH+1];     //      1816        12     margin currency (szchar)

   BYTE   unknown_12[104];                         //      1828       104
   UINT   unknown_13;                              //      1932         4     ?
};                                                 // ----------------------------------------------------------------------------------------------------------------
